////////////////////////////////////////////////////////////////////////
//
//        File  Name : irc-client.cc
//        Class Name : 
//        Author     : Young-ki Hwang
//        Date       : April 30, 1996
//        Description: Main program of the client part.
//                     
//
///////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include <curses.h>
#include <stdio.h>
#include <signal.h>
#include "win.h"
#include "terminal.h"
#include "client.h"
#include "signal.h"
#include "fork.h"




extern "C" pause();
extern "C" wait(int *);


main(int argc, char *argv[])
{
  char buf[MAX_MSG_SIZE], buf1[MAX_MSG_SIZE], id[MAX_MSG_SIZE], ch, temp[MAX_MSG_SIZE];
  int  pid, i;
 
  if(argc != 2)
     { cout << " Usage : irc-client  server_address ";
       exit(1);
     }
  forks  fork1;
  signals signal1;
  strings string1;

  // Connect to the server.
  client client1(argv[1]);
  client1.initialize();
  client1.make_connection();
  cout << "CONNECTION MADE TO IRC_SERVER !!!\n\n";
  
  // Show how many people are inside.
  cout << " #       ID \n";
  cout << "====================\n";
  for( i=1; i>0; i++)
   {  while(!client1.receive(id)); 
      if( string1.compare(id, "end") )
	 break;
      cout<< i << "   : " << id << endl;
    }
   cout << "====================\n"; 
   cout << i-1 << " people are inside !!! \n";
   cout << "Do you want to continue ? (Y/N) :";
   cin >> ch;
   // If No, exit.
   if( (ch=='n') || (ch=='N') )
      { while(!client1.send("stop"));
	exit(1);
	}
   // If Yes, go ahead.
   else while(!client1.send("ok"));

  // Get a user's id. If somebody is using a id, try it again.
  do
    { client1.get_id(id);
      while(!client1.send(id));
      while(!client1.receive(buf));
      cout<< id << endl;
    }while(!string1.compare(buf, "ok"));
  

  // Set up the terminal typ data.
  terminal term;
  term.makenoecho();
  term.makenonl();
  term.makecbreak();

  // Make a window for the client.
  window win1(term.getmaxline()-5, term.getmaxcol(), 0, 0);
  window win2(4, term.getmaxcol(), term.getmaxline()-4, 0) ;
  window win3(term.getmaxline()-7, term.getmaxcol()-2, 1, 1);
  window win4(1, term.getmaxcol()/2,  term.getmaxline()-5, 0) ;
  window win5(1, term.getmaxcol()/2,  term.getmaxline()-5, term.getmaxcol()/2) ;

  win1.drawborder('|', '-');

  win3.makescroll();

  win4.moveto(0, 2);
  win4.putstring("[ /help ] [/quit]          My ID is :");
  win5.putstring(id);

  win2.drawborder(' ', '-');
  win2.moveto(1, 0);
  win2.cleartoeol();

  // Make a child process.
  pid = fork1.make_child();

  // Child process; receive a message form the server and display it.
  if (pid ==0)
    { 
      while(1)
       { while(!client1.receive(buf1));
	 win3.putstring(buf1);
	
	 win2.moveto(1, 0);
	}       
     }/* end if : child*/

  // Parent process; receive an input from the window and send it to server.
  else
    { 
      while(1)
       { // Get a input string from the window.
	 win2.getstring(buf);
	 string1.scan(buf, temp);

	 // If input is "/quit", exit the program.
	 if( string1.compare( buf, "/quit") )
	   { while(!client1.send(buf));
	     signal1.send(0, SIGTERM);
	     exit(0);
	   }

         // If input is "/nick", change the id.
	 else if( string1.compare( temp, "/nick") )
	  { string1.copy(buf1, buf);
	    string1.leftshift(buf1, 6);
	    string1.scan(buf1, id);
	    win5.moveto(0, 0);
	    win5.putstring(id);
	    client1.send(buf);
	    win2.moveto(1, 0);
            win2.cleartoeol();
	   }

	 // Otherwise, send the input to the server.
	 else
	   {
	     while(!client1.send(buf));
	     
	     win2.moveto(2, 0);
	     win2.cleartoeol();
	     win2.moveto(1, 0);
	     win2.cleartoeol();
	   }/* end else */

	 }/* end while */
    }/* end else : parent */
}/* end main() */









